class c extends Error {
  constructor(r) {
    super(r), this.code = r;
  }
  static throw_error(r) {
    throw new c(r);
  }
  static throw_unknown_error(r) {
    throw Error(r);
  }
}
class a {
  /**
   * Role constructor
   */
  constructor(r = []) {
    this.permissions = [], this.permissions = r;
  }
  formatPermission(r) {
    switch (r) {
      case "create":
        return "c";
      case "read":
        return "r";
      case "update":
        return "u";
      case "delete":
        return "d";
      case "list":
        return "l";
      default:
        return r;
    }
  }
  addPermission(r) {
    return this.permissions.push(r), this;
  }
  removePermission(r) {
    return this.permissions = this.permissions.filter((e) => e.resource !== r), this;
  }
  updatePermission(r) {
    return this.permissions = this.permissions.map((e) => e.resource === r.resource ? r : e), this;
  }
  canCreate(r) {
    return this.can("create", r);
  }
  canRead(r) {
    return this.can("read", r);
  }
  canUpdate(r) {
    return this.can("update", r);
  }
  canDelete(r) {
    return this.can("delete", r);
  }
  canList(r) {
    return this.can("list", r);
  }
  can(r, e) {
    const t = this.formatPermission(r), s = this.permissions.find((i) => i.resource === e);
    return s ? s.scopes.includes(t) : !1;
  }
  canAny(r, e) {
    return Array.isArray(r) ? r.some((t) => this.can(t, e)) : this.can(r, e);
  }
  canAll(r, e) {
    return Array.isArray(r) ? r.every((t) => this.can(t, e)) : this.can(r, e);
  }
  extend(r, e) {
    var t, s, i;
    return Array.isArray(e) ? (e = { permissions: e }, r.permissions.forEach((n) => {
      this.addPermission(n);
    }), (t = e == null ? void 0 : e.permissions) == null || t.forEach((n) => {
      this.addPermission(n);
    }), this) : e ? e.overwrite ? (this.permissions = r.permissions, e.permissions && ((s = e.permissions) == null || s.forEach((n) => {
      this.permissions.find(
        (o) => o.resource === n.resource
      ) ? this.updatePermission(n) : this.addPermission(n);
    })), this) : (e.permissions && (this.permissions = r.permissions, (i = e.permissions) == null || i.forEach((n) => {
      this.permissions.find((o) => o.resource === n.resource) || this.addPermission(n);
    })), this) : (r.permissions.forEach((n) => {
      this.addPermission(n);
    }), this);
  }
  generate(r = "json") {
    const e = {};
    return this.permissions.forEach((t) => {
      const s = t.resource, i = t.scopes;
      e[s] = {
        create: i.includes("c"),
        read: i.includes("r"),
        update: i.includes("u"),
        delete: i.includes("d"),
        list: i.includes("l")
      };
    }), r === "json" ? JSON.stringify(e) : e;
  }
  toJSON() {
    return this.generate("json");
  }
  toObject() {
    return this.generate("object");
  }
  /**
   * Load a role from a json string
   * @param json - Json string to load
   */
  static fromJSON(r) {
    const e = JSON.parse(r);
    return a.fromObject(e);
  }
  /**
   * Load a role from a javascript object
   * @param object - Object to load
   */
  static fromObject(r) {
    const e = [];
    return Object.keys(r).forEach((t) => {
      let s = "";
      Object.keys(r[t]).forEach((i) => {
        r[t][i] ? s += i[0] : s += "-";
      }), e.push({
        resource: t,
        scopes: s
      });
    }), new a(e);
  }
  static validate(r, e) {
    try {
      const t = r.permissions.every((s) => this.validatePermission(s));
      return e && e(t), t;
    } catch (t) {
      return e && e(!1, t), !1;
    }
  }
  static validatePermission(r) {
    if (!r.resource)
      throw new Error("Resource is required");
    if (!r.scopes)
      throw new Error("Scopes are required");
    if (r.scopes.length !== 5)
      throw new Error("Scopes must be 5 characters long");
    if (!r.scopes.match(/^[crudl-]+$/))
      throw new Error("Scopes must be in the format of crudl");
    return !0;
  }
}
class f {
  constructor(r) {
    this.roles = new Map(Object.entries(r.roles)), this.resources = new Set(r.resources);
  }
  _checkRole(r) {
    return this.roles.has(r);
  }
  _checkResource(r) {
    return Array.isArray(r) ? r.every((e) => this.resources.has(e)) : this.resources.has(r);
  }
  _getRole(r, e, t) {
    try {
      let s;
      if (e) {
        if (s = a.fromObject(t), !s)
          throw new c("INVALID_PERMISSIONS");
        return s;
      }
      if (s = this.roles.get(r), !s)
        throw new c("INVALID_ROLE");
      return s;
    } catch (s) {
      throw c.throw_unknown_error(s);
    }
  }
  _verifyPermissionsStrict(r, e, t) {
    try {
      return e.every((s) => t.every((i) => r.can(s, i)));
    } catch (s) {
      throw c.throw_unknown_error(s);
    }
  }
  _verifyPermissionsLoose(r, e, t) {
    try {
      const s = /* @__PURE__ */ new Set();
      return t.forEach((i) => {
        r.canAny(e, i) && s.add(i);
      }), s.size > 0;
    } catch (s) {
      throw c.throw_unknown_error(s);
    }
  }
  _verifyOptions(r) {
    const { role: e, action: t, resource: s, constructRole: i, permissions: n, loose: h } = r;
    if (!t)
      throw c.throw_error("MISSING_ACTION");
    if (!s)
      throw c.throw_error("MISSING_RESOURCE");
    if (!i && !this._checkRole(e))
      throw c.throw_error("INVALID_ROLE");
    if (!this._checkResource(s))
      throw c.throw_error("INVALID_RESOURCE");
    return {
      role: e,
      action: t,
      resource: s,
      constructRole: i,
      permissions: n,
      loose: h
    };
  }
  authorizeRole(r) {
    try {
      const { role: e, action: t, resource: s, constructRole: i, permissions: n, loose: h } = this._verifyOptions(r), o = this._getRole(e, i, n);
      return Array.isArray(t) ? Array.isArray(s) ? h ? this._verifyPermissionsLoose(o, t, s) : this._verifyPermissionsStrict(o, t, s) : h ? this._verifyPermissionsLoose(o, t, [s]) : this._verifyPermissionsStrict(o, t, [s]) : Array.isArray(s) ? h ? this._verifyPermissionsLoose(o, [t], s) : this._verifyPermissionsStrict(o, [t], s) : h ? this._verifyPermissionsLoose(o, [t], [s]) : this._verifyPermissionsStrict(o, [t], [s]);
    } catch (e) {
      throw c.throw_unknown_error(e);
    }
  }
}
export {
  c as AuthError,
  f as AuthManager,
  a as Role
};
